/* SccsId = "@(#)dmproto.h 3.14 (TU-Delft) 08/11/00" */
/**********************************************************

Name/Version      : The Design Data Management Project

Language          : C
Operating system  : UNIX SYSTEM V
Host machine      : HP9000/S500

Author(s)         : S. de Graaf
                    T.G.R. van Leuken
                    N. van der Meijs
		    P. van der Wolf
Creation date     : 04-Dec-1986
Modified by       : S. de Graaf
Modification date : 17-May-1988
Modification date : 01-Feb-1999
Modification date : 16-Jun-2000
Modification date : 28-Jun-2000 (3.12)
Modified by       : P. Bingley
Modification date : 15-Nov-1989


        Delft University of Technology
        Department of Electrical Engineering
        Network Theory Section
        Mekelweg 4 - P.O.Box 5031
        2600 GA Delft
        The Netherlands

        COPYRIGHT (C) 1985-2000, All rights reserved
**********************************************************/

#ifndef _DMPROTO_INCLUDED
#define _DMPROTO_INCLUDED /* allows multiple inclusion */
# if defined(__STDC__) || defined(__cplusplus) || defined(WIN32)
# ifdef __cplusplus
  extern "C" {
# endif
DM_CELL *dmCheckOut(DM_PROJECT *dmproject, char *cell, char *versionstatus, int versionnumber, char *view, int mode);
DM_PROJECT *dmFindProjKey(int loc_imp, char *local_name, DM_PROJECT *father_proj, char **rem_namep, char *view);
DM_PROJECT *dmOpenProject(char *projectname, int mode);
DM_STREAM *dmOpenStream(DM_CELL *key, char *stream, char *mode);
char *dmAttrPrint(char *attr, char *last, char *par, char *val);
char *dmAttrScan(char *attr, char **par, char **val);
int dmCheckIn(DM_CELL *key, int mode);
void dmCkinAll(int mode);
void dmCloseCellStreams(DM_CELL *cellkey, int mode);
int dmCloseProject(DM_PROJECT *dmproject, int mode);
int dmCloseProjectContinue(DM_PROJECT *dmproject);
int dmCloseStream(DM_STREAM *dmfile, int mode);
void dmError(char *s);
void dmError2(char *s1, char *s2);
int dmGetDataEscape(DM_STREAM *dmfile, int fmt);
int dmGetDesignData(DM_STREAM *dmfile, int fmt);
int dmInit(char *progname);
void dmPerror(char *s);
int dmPrintf(DM_STREAM *iop, char *format, ...);
int dmPutDataEscape(DM_STREAM *dmfile, int fmt);
int dmPutDesignData(DM_STREAM *dmfile, int fmt);
int dmQuit(void);
int dmRemoveCell(DM_PROJECT *dmproject, char *cell, char *versionstatus, int versionnumber, char *view);
int dmRenameStream(DM_CELL *key, char *oldname, char *newname);
int dmRmCellForce(DM_PROJECT *dmproject, char *cell, char *versionstatus, int versionnumber, char *view, int force);
int dmScanf(DM_STREAM *iop, char *fmt, ...);
int dmSeek(DM_STREAM *dmfile, long offset, long ptrname);
/* gcc 2.3.3 warns about using "struct stat" here... */
typedef struct stat _STRUCT_STAT_;
int dmStat(DM_CELL *key, char *file, _STRUCT_STAT_ *buf);
long dmTell(DM_STREAM *dmfile);
int dmTestname(char *name);
int dmTestname2(DM_PROJECT *dmproject, char *name);
int dmUnlink(DM_CELL *key, char *file);
char *dmGetMetaDesignData(int reqid, DM_PROJECT *projectid, ...);
char *dmPutMetaDesignData(int reqid, DM_PROJECT *projectid, ...);
char *dmSubstituteEnvironmentVars(char *path);
#ifdef XCONTROL
FILE *dmOpenXData(DM_PROJECT *project, char *mode);
int dmGetCellStatus(DM_PROJECT *project, DM_XDATA *xdata);
int dmGetXData(FILE *fp, DM_XDATA *xdata);
int dmPutCellStatus(DM_PROJECT *project, DM_XDATA *xdata);
int dmPutXData(FILE *fp, DM_XDATA *xdata);
int dmStatXData(DM_PROJECT *project, struct stat *buf);
int dmUnlinkXData(DM_PROJECT *project);
#endif
#ifdef DM_GETOPT
int getopt(int argc, char **argv, char *opts);
#endif
# ifdef __cplusplus
  }
# endif
#  else /* not __STDC__ */
DM_CELL *dmCheckOut();
DM_PROJECT *dmFindProjKey();
DM_PROJECT *dmOpenProject();
DM_STREAM *dmOpenStream();
char *dmAttrPrint();
char *dmAttrScan();
int dmCheckIn();
void dmCkinAll();
void dmCloseCellStreams();
int dmCloseProject();
int dmCloseProjectContinue();
int dmCloseStream();
void dmError();
void dmError2();
int dmGetDataEscape();
int dmGetDesignData();
int dmInit();
void dmPerror();
int dmPrintf();
int dmPutDataEscape();
int dmPutDesignData();
int dmQuit();
int dmRemoveCell();
int dmRenameStream();
int dmRmCellForce();
int dmScanf();
int dmSeek();
int dmStat();
long dmTell();
int dmTestname();
int dmTestname2();
int dmUnlink();
char *dmGetMetaDesignData();
char *dmPutMetaDesignData();
char *dmSubstituteEnvironmentVars();
#ifdef XCONTROL
FILE *dmOpenXData();
int dmGetCellStatus();
int dmGetXData();
int dmPutCellStatus();
int dmPutXData();
int dmStatXData();
int dmUnlinkXData();
#endif
#ifdef DM_GETOPT
int getopt ();
#endif
#  endif /* else not __STDC__ */
#endif /* _DMPROTO_INCLUDED */
